#ifndef AVERAGE_H
#define AVERAGE_H

#include "prep_defs.h"
#include "rb-trees.h"
#include "lists.h"

/*********************************************************/

struct average_properties {
	double average_grade;
	double arithmiths;
	double paronomasths;
	double lowest_grade;
	double highest_grade;
	KEY_TYPE basika [5];
	KEY_TYPE epiloghs [11];
	int get_ptyxio;
};

typedef struct average_properties AVERAGE_PROPERTIES;
typedef AVERAGE_PROPERTIES *AVERAGE_PROPERTIESPTR;

struct average_reply {
	AVERAGE_PROPERTIESPTR prwtos_tomeas;	// Epi8ymei katoxyrwsh katey8ynshs prwtou tomea.
	AVERAGE_PROPERTIESPTR deyteros_tomeas;	// Epi8ymei katoxyrwsh katey8ynshs deyterou tomea.
	AVERAGE_PROPERTIESPTR tritos_tomeas;	// Epi8ymei katoxyrwsh katey8ynshs tritou tomea.
	AVERAGE_PROPERTIESPTR uniform;			// Den epi8ymei katoxyrwsh katey8ynshs.
};

typedef struct average_reply AVERAGE_REPLY;
typedef AVERAGE_REPLY * AVERAGE_REPLYPTR;

struct average_fluctuation {
	double arithmiths;
	double paronomasths;
	double average_grade;
	LISTPTR ypoxrewtika;
	LISTPTR basika;
	LISTPTR epiloghs;
	LISTPTR ptyxiakh;
	int number_of_lessons;
};

typedef struct average_fluctuation FLUCTUATION_AVERAGE;
typedef FLUCTUATION_AVERAGE *FLUCTUATION_AVERAGEPTR;


/*********************************************************/

AVERAGE_REPLYPTR calculate_average (TREEPTR Tree);
/* Average Grade based on certain Section */
int calculate_average_following_certain_section (const int section, AVERAGE_PROPERTIESPTR average, 
										LISTPTR ypoxrewtika, LISTPTR BK_1, LISTPTR BK_2, LISTPTR BK_3,
										LISTPTR epiloghs, const int ptyxiakh, double ptyxiakh_grade);
int stroggylopoihsh (double number);
double calculate_period_average (TREEPTR Tree, KEY_TYPE period [ARRAY_SIZE]);

void manage_average_fluctuation (TREEPTR Tree, LISTPTR period, 
								 FLUCTUATION_AVERAGEPTR average, const int tomeas);
/*
double calculate_average_fluctuation (TREEPTR Tree, KEY_TYPE period [ARRAY_SIZE], 
									  FLUCTUATION_AVERAGEPTR average);
*/
void insert_epiloghs_average_fluctuation (FLUCTUATION_AVERAGEPTR average, 
										  LIST_NODEPTR current_list_node);
void insert_basiko_average_fluctuation (FLUCTUATION_AVERAGEPTR average, LIST_NODEPTR current_list_node, 
										const int tomeas);

/*********************************************************/

#endif