#include "display_tree.h"

int display_tree_with_keys (TREEPTR Tree)
{
	int result;
	
	CLEARSCREEN;
	show_logo ();
	printf ("Tree's Nodes and Leaves with their corresponding Keys:\n\n");

	result = display_subtree (Tree, Tree->ROOT, 0, KEY_DISPLAY);
	fflush (stdout);

	return result;		// Indicate successful display.
}

int display_tree_with_colors (TREEPTR Tree)
{
	int result;
	
	CLEARSCREEN;
	show_logo ();
	printf ("Tree's Nodes and Leaves with their corresponding Colors:\n\n");

	result = display_subtree (Tree, Tree->ROOT, 0, COLOR_DISPLAY);
	fflush (stdout);

	return result;		// Indicate successful display.
}

int display_subtree (TREEPTR Tree, TREE_NODEPTR Node, int indent_so_far, const int display_selection)
{
	int i;
	int new_indent;
	
	if (display_selection == KEY_DISPLAY)
		new_indent = KEY_DISPLAY_INDENT + indent_so_far;
	else
		new_indent = COLOR_DISPLAY_INDENT + indent_so_far;

	if (Node->right_child != Tree->NIL) {
		display_subtree (Tree, Node->right_child, new_indent, display_selection);
	}


	for (i = 1; i<= indent_so_far; i++) {
		printf (" ");
	}
	if (display_selection == KEY_DISPLAY) {
		printf ("%6d\n", Node->key);
		fflush (stdout);
	}
	else {
		printf ("%s\n", (Node->color == RED ? "RED" : "BLACK"));
		fflush (stdout);
	}


	if (Node->left_child != Tree->NIL) {
		display_subtree (Tree, Node->left_child, new_indent, display_selection);
		printf ("\n");
	}


	return 1;			// Indicate successful display.
}
