#ifndef LISTS_H
#define LISTS_H

#include "prep_defs.h"
#include "rb-trees.h"

/*****************************************************************************/

struct list_node {
	KEY_TYPE key_code;
	TREE_NODEPTR lesson_node;
	struct list_node *next;
	struct list_node *previous;
};

typedef struct list_node LIST_NODE;
typedef struct list_node * LIST_NODEPTR;

struct list {
	LIST_NODEPTR HEAD;
	LIST_NODEPTR NIL;
	int NUMBER_OF_ELEMENTS;
};

typedef struct list LIST;
typedef struct list * LISTPTR;

/*****************************************************************************/

/* Necessary Initializations */
LISTPTR LIST__Initialize ();
/* List's Search Operation */
LIST_NODEPTR LIST__Search (LISTPTR list, KEY_TYPE key);
/* Insert node at front - Do not allow duplicate insertions according to key */
int LIST__Insert_node_at_front (LISTPTR list, KEY_TYPE lesson_code, TREE_NODEPTR lesson_tree_node);
/* Search List for a node with KEY == key and if found, delete it. */
int LIST__Delete_node_according_to_key (LISTPTR list, KEY_TYPE key);
/* Destroy List */
int LIST__Destroy (LISTPTR list);
/* Swap Nodes in List */
int LIST__Swap_nodes (LISTPTR List, LIST_NODEPTR node1, LIST_NODEPTR node2);

/* Union of 2 lists */
/* The new list does not have duplicate copies of the same element */
LISTPTR LIST__Union (LISTPTR list1, LISTPTR list2);

/* BubbleSort applied on Lists - DECREASING ORDER */
void LIST__BubbleSort (LISTPTR List);

/*****************************************************************************/

#endif